from copy import deepcopy

class Model:
    """A convenient place to store View data persistently."""

    def __init__(self):
        # simple key-value pairs
        self.screen = None
        self.title = None
        self.scene_stack = []
        self.deferred_req = None
        # view-specific data, to be used when e.g. resizing the window
        self._initial_viewdata = {
            'adduser': {
                'uid': '',
                'cn': '',
                'program': '',
                'forwarding_address': '',
                'num_terms': '1',
            },
            'transaction': {
                'op_layout': None,
                'msg_layout': None,
                'labels': {},
                'status': 'not started',
            },
        }
        self.viewdata = deepcopy(self._initial_viewdata)
        # data which is shared between multiple views
        self.for_member = True
        self.confirm_lines = None
        self.operations = None

    def reset_viewdata(self):
        self.viewdata = deepcopy(self._initial_viewdata)
